## morph-browser 1.1.2+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(morph-browser VERSION 1.1.2 LANGUAGES CXX)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

find_package(Gettext REQUIRED)

option(CLICK_MODE "Build as a click package" off)

# Standard install paths
include(GNUInstallDirs)

#set install paths
if(CLICK_MODE)
  set(CMAKE_INSTALL_PREFIX "/")
  set(CMAKE_INSTALL_BINDIR "/")
  set(CMAKE_INSTALL_FULL_DATADIR "./share")
  add_definitions("-DCLICK_MODE")
endif()

string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower)

include(EnableCoverageReport)
#####################################################################
# Enable code coverage calculation with gcov/gcovr/lcov
# Usage:
#  * Switch build type to coverage (use ccmake or cmake-gui)
#  * Invoke make, make test, make coverage (or ninja if you use that backend)
#  * Find html report in subdir coveragereport
#  * Find xml report feasible for jenkins in coverage.xml
#####################################################################
if(cmake_build_type_lower MATCHES coverage)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage" )
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} --coverage" )
    set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} --coverage" )
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} --coverage" )
    ENABLE_COVERAGE_REPORT(EXCLUDES tests/*|.*moc_.*.cpp FILTER tests/* moc_*.cpp)
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")

# enable QML debugging
if(CMAKE_BUILD_TYPE MATCHES DEBUG OR CMAKE_BUILD_TYPE MATCHES "Debug")
    add_definitions(-DQT_QML_DEBUG)
endif()

include(qt5)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)

set(DESKTOP_FILE morph-browser.desktop)

# uninstall target
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)
add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

add_subdirectory(src)

enable_testing()
add_subdirectory(tests)

# make non compiled files (QML, JS, images, etc.) visible in QtCreator
file(GLOB NON_COMPILED_ROOT *.png .gitignore COPYING README snapcraft.yaml)
file(GLOB_RECURSE NON_COMPILED_SUBDIRS
     debian/*.dirs debian/*.install debian/*.lintian-overrides debian/*.manifest
     debian/compat debian/control debian/copyright debian/rules debian/source/format
     debian/tests/*
     doc/*.css doc/*.qdoc doc/*.qdocconf
     po/*.po po/*.pot
     snap/morph-browser.launcher
     src/*.js src/*.qml src/*.sci src/README
     tests/*.py tests/*.qml)
add_custom_target(NON_COMPILED_TARGET ALL SOURCES ${NON_COMPILED_ROOT} ${NON_COMPILED_SUBDIRS})

set(GETTEXT_PACKAGE "morph-browser")

add_subdirectory(po)

add_subdirectory(doc)

install(FILES morph-browser.svg DESTINATION ${CMAKE_INSTALL_DATADIR}/morph-browser)
install(FILES morph-browser-splash.svg DESTINATION ${CMAKE_INSTALL_DATADIR}/morph-browser)
add_subdirectory(click-hooks)

=== click-hooks/CMakeLists.txt ===
project(webapp-container-hook)

find_package(Qt5Core REQUIRED)

include_directories(
    ${CMAKE_BINARY_DIR}
    ${webbrowser-common_SOURCE_DIR}
    ${webbrowser-common_BINARY_DIR}
)

set(WEBAPP_CONTAINER_HOOK_FOLDER webapp-container)

set(WEBAPP_CONTAINER_HOOK webapp-container-hook)

add_definitions(-DWEBAPP_CONTAINER_HOOK_FOLDER="${WEBAPP_CONTAINER_HOOK_FOLDER}")

set(WEBAPP_CONTAINER_HOOK_SRC
    hook.cpp
    hook-utils.h
    hook-utils.cpp
)

add_executable(${WEBAPP_CONTAINER_HOOK} ${WEBAPP_CONTAINER_HOOK_SRC})
target_link_libraries(${WEBAPP_CONTAINER_HOOK}
    Qt5::Core
)

install(TARGETS ${WEBAPP_CONTAINER_HOOK}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

configure_file(
    webapp-container.hook.in
    ${CMAKE_CURRENT_BINARY_DIR}/webapp-container.hook
    @ONLY)

file(GLOB WEBAPP_CONTANER_HOOK_FILES ${CMAKE_CURRENT_BINARY_DIR}/*.hook)
install(FILES ${WEBAPP_CONTANER_HOOK_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/click/hooks)

=== doc/CMakeLists.txt ===
project(morph-web-doc)

find_program(QDOC_EXECUTABLE qdoc)
if(QDOC_EXECUTABLE STREQUAL "QDOC_EXECUTABLE-NOTFOUND")
    message(WARNING "qdoc not found, documentation cannot be built")
else()
    add_custom_target(doc ALL
                      COMMAND ${QDOC_EXECUTABLE} -qt5
                      -outputdir ${CMAKE_CURRENT_BINARY_DIR}/html
                    ${CMAKE_CURRENT_SOURCE_DIR}/morph-web.qdocconf)
    install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
    DESTINATION ${CMAKE_INSTALL_DATADIR}/doc/morph-web)
endif()

=== src/Morph/CMakeLists.txt ===
set(QT_INSTALL_QML "/usr/lib/${CMAKE_LIBRARY_ARCHITECTURE}/qt5/qml")

execute_process(COMMAND lsb_release --short --release
    OUTPUT_VARIABLE UBUNTU_VERSION OUTPUT_STRIP_TRAILING_WHITESPACE)
add_definitions(-DUBUNTU_VERSION="${UBUNTU_VERSION}")

add_subdirectory(Web)

=== src/Morph/Web/CMakeLists.txt ===
project(morph-web-plugin)

find_package(Qt5Core REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5Qml REQUIRED)

set(MORPH_WEB_IMPORTS_DIR "${QT_INSTALL_QML}/Morph/Web")

set(PLUGIN morph-web-plugin)

set(PLUGIN_SRC plugin.cpp)

add_library(${PLUGIN} MODULE ${PLUGIN_SRC})
target_link_libraries(${PLUGIN}
    Qt5::Core
    Qt5::Gui
    Qt5::Qml
)

file(GLOB UA_OVERRIDES_IN RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} ua-overrides-*.js.in)
foreach(_file ${UA_OVERRIDES_IN})
  string(REGEX REPLACE "\\.in$" "" OUTFILE ${_file})
  configure_file(${_file} ${CMAKE_CURRENT_BINARY_DIR}/${OUTFILE} @ONLY)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${OUTFILE}
          DESTINATION ${MORPH_WEB_IMPORTS_DIR})
endforeach(_file)

file(GLOB PLUGIN_FILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.qml qmldir *.js *.png)
install(TARGETS ${PLUGIN} DESTINATION ${MORPH_WEB_IMPORTS_DIR})
install(FILES ${PLUGIN_FILES} DESTINATION ${MORPH_WEB_IMPORTS_DIR})

if(NOT ${CMAKE_CURRENT_BINARY_DIR} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR})
  # copy qml files over to build dir to be able to import them uninstalled
  foreach(_file ${PLUGIN_FILES})
    add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${_file}
                       DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${_file}
                       COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_CURRENT_SOURCE_DIR}/${_file} ${CMAKE_CURRENT_BINARY_DIR}/${_file})
  endforeach(_file)
  add_custom_target(copy_files_to_build_dir DEPENDS ${PLUGIN_FILES})
  add_dependencies(${PLUGIN} copy_files_to_build_dir)
endif()

=== src/app/webbrowser/CMakeLists.txt ===
project(webbrowser-app)

find_package(Qt5Concurrent REQUIRED)
find_package(Qt5Sql REQUIRED)

include_directories(
    ${CMAKE_BINARY_DIR}
    ${webbrowser-common_SOURCE_DIR}
    ${webbrowser-common_BINARY_DIR}
)

set(WEBBROWSER_APP_MODELS_SRC
    bookmarks-model.cpp
    bookmarks-folder-model.cpp
    bookmarks-folderlist-model.cpp
    history-domain-model.cpp
    history-domainlist-model.cpp
    history-lastvisitdatelist-model.cpp
    history-model.cpp
    limit-proxy-model.cpp
    tabs-model.cpp
    text-search-filter-model.cpp
)

set(WEBBROWSER_APP_MODELS morph-browser-models)

add_library(${WEBBROWSER_APP_MODELS} STATIC ${WEBBROWSER_APP_MODELS_SRC})
target_link_libraries(${WEBBROWSER_APP_MODELS}
    Qt5::Core
    Qt5::Sql
#    Qt5::WebEngine
)

set(WEBBROWSER_APP_SRC
    reparenter.cpp
    searchengine.cpp
    morph-browser.cpp
)

set(WEBBROWSER_APP morph-browser)

add_executable(${WEBBROWSER_APP} ${WEBBROWSER_APP_SRC})
target_link_libraries(${WEBBROWSER_APP}
    Qt5::Concurrent
    Qt5::Core
    Qt5::Qml
    Qt5::Quick
    ${COMMONLIB}
    ${WEBBROWSER_APP_MODELS}
)

install(TARGETS ${WEBBROWSER_APP}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

file(GLOB QML_FILES *.qml qmldir *.js)
install(FILES ${QML_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/morph-browser/webbrowser)

install(DIRECTORY assets
        DESTINATION ${CMAKE_INSTALL_DATADIR}/morph-browser/webbrowser
        FILES_MATCHING PATTERN *.png PATTERN *.svg PATTERN *.sci)

install(DIRECTORY searchengines
        DESTINATION ${CMAKE_INSTALL_DATADIR}/morph-browser/webbrowser
        FILES_MATCHING PATTERN *.xml)

configure_file(${DESKTOP_FILE}.in.in ${DESKTOP_FILE}.in @ONLY)
add_custom_target(${DESKTOP_FILE} ALL
    COMMENT "Merging translations into ${DESKTOP_FILE}"
    COMMAND ${GETTEXT_MSGFMT_EXECUTABLE}
            --desktop --template=${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE}.in
            -o ${DESKTOP_FILE}
            -d ${CMAKE_SOURCE_DIR}/po
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE}
        DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)

install(FILES "morph-browser.url-dispatcher"
        DESTINATION ${CMAKE_INSTALL_DATADIR}/lomiri-url-dispatcher/urls)

install(FILES "morph-browser-content-hub.json"
    DESTINATION ${CMAKE_INSTALL_DATADIR}/lomiri-content-hub/peers
    RENAME morph-browser
    )

if(${CLICK_MODE})
  message("-- Configuring manifest.json")

  execute_process(
    COMMAND dpkg-architecture -qDEB_HOST_ARCH
    OUTPUT_VARIABLE CLICK_ARCH
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )

  configure_file(manifest.json.in ${CMAKE_CURRENT_BINARY_DIR}/manifest.json)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/manifest.json DESTINATION ${CMAKE_INSTALL_PREFIX})
  install(FILES morph-browser.apparmor DESTINATION ${CMAKE_INSTALL_PREFIX})
endif()

=== tests/unittests/cookie-store/CMakeLists.txt ===
find_package(Qt5Core REQUIRED)
find_package(Qt5Network REQUIRED)
find_package(Qt5Sql REQUIRED)
find_package(Qt5Test REQUIRED)
set(TEST tst_CookieStoreTests)
set(SOURCES
    ${webapp-container_SOURCE_DIR}/chrome-cookie-store.cpp
    ${webapp-container_SOURCE_DIR}/cookie-store.cpp
    ${webapp-container_SOURCE_DIR}/oxide-cookie-helper.cpp
    tst_CookieStore.cpp
)
add_executable(${TEST} ${SOURCES})
include_directories(${webapp-container_SOURCE_DIR})
target_link_libraries(${TEST}
    Qt5::Core
    Qt5::Network
    Qt5::Sql
    Qt5::Test
)
add_test(${TEST} ${CMAKE_CURRENT_BINARY_DIR}/${TEST})

=== tests/unittests/limit-proxy-model/CMakeLists.txt ===
find_package(Qt5Core REQUIRED)
find_package(Qt5Sql REQUIRED)
find_package(Qt5Test REQUIRED)
set(TEST tst_LimitProxyModelTests)
add_executable(${TEST} tst_LimitProxyModelTests.cpp)
include_directories(${webbrowser-app_SOURCE_DIR})
target_link_libraries(${TEST}
    Qt5::Core
    Qt5::Sql
    Qt5::Test
    morph-browser-models
)
add_test(${TEST} ${CMAKE_CURRENT_BINARY_DIR}/${TEST})

=== tests/unittests/oxide-cookie-helper/CMakeLists.txt ===
find_package(Qt5Core REQUIRED)
find_package(Qt5Network REQUIRED)
find_package(Qt5Test REQUIRED)
set(TEST tst_OxideCookieHelperTests)
set(SOURCES
    ${webapp-container_SOURCE_DIR}/oxide-cookie-helper.cpp
    tst_OxideCookieHelper.cpp
)
add_executable(${TEST} ${SOURCES})
include_directories(${webapp-container_SOURCE_DIR})
target_link_libraries(${TEST}
    Qt5::Core
    Qt5::Network
    Qt5::Test
)
add_test(${TEST} ${CMAKE_CURRENT_BINARY_DIR}/${TEST})

=== tests/unittests/session-utils/CMakeLists.txt ===
find_package(Qt5Core REQUIRED)
find_package(Qt5Test REQUIRED)
set(TEST tst_SessionUtilsTests)
set(SOURCES
    ${webapp-container_SOURCE_DIR}/session-utils.cpp
    tst_SessionUtilsTests.cpp
)
add_executable(${TEST} ${SOURCES})
include_directories(${webapp-container_SOURCE_DIR})
target_link_libraries(${TEST}
    Qt5::Core
    Qt5::Test
)
add_test(${TEST} ${CMAKE_CURRENT_BINARY_DIR}/${TEST})

=== tests/unittests/text-search-filter-model/CMakeLists.txt ===
find_package(Qt5Core REQUIRED)
find_package(Qt5Sql REQUIRED)
find_package(Qt5Test REQUIRED)
set(TEST tst_TextSearchFilterModelTests)
add_executable(${TEST} tst_TextSearchFilterModelTests.cpp)
include_directories(${webbrowser-app_SOURCE_DIR})
target_link_libraries(${TEST}
    Qt5::Core
    Qt5::Sql
    Qt5::Test
    morph-browser-models
)
add_test(${TEST} ${CMAKE_CURRENT_BINARY_DIR}/${TEST})

=== tests/unittests/webapp-container-hook/CMakeLists.txt ===
find_package(Qt5Core REQUIRED)
find_package(Qt5Test REQUIRED)
set(TEST tst_WebappContainerHookTests)
set(SOURCES
    ${CMAKE_SOURCE_DIR}/click-hooks/hook-utils.cpp
    tst_WebappContainerHookTests.cpp
)
set(WEBAPP_CONTAINER_HOOK webapp-container-hook)
include_directories(${CMAKE_SOURCE_DIR})
add_definitions(-DCLICK_HOOK_EXEC_BIN="${CMAKE_BINARY_DIR}/click-hooks/${WEBAPP_CONTAINER_HOOK}")
add_executable(${TEST} ${SOURCES})
target_link_libraries(${TEST}
    Qt5::Core
    Qt5::Test
)
add_test(${TEST} ${CMAKE_CURRENT_BINARY_DIR}/${TEST})

=== debian/changelog ===
morph-browser (1.1.2+dfsg-3) unstable; urgency=medium

  * Re-upload source-only as is.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 06 Feb 2025 11:47:29 +0100

morph-browser (1.1.2+dfsg-2) unstable; urgency=medium

  * debian/{control,rules}:
    + Add bin:pkg morph-webapp-container.
  * debian/patches:
    + Add 1001_namespace-fixes-for-webapp.patch. Use better namespacing for the
      webapp-container binaries.
  * debian/morph-webapp-container.install:
    + Adjust to namespacing changes for webapp-container.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 20 Jan 2025 10:25:03 +0100

morph-browser (1.1.2+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Drop 2003_test-waiting-adjust-to-slow-archs.patch. Problem solved in
      latest upstream release.
  * debian/copyright:
    + Update copyright attributions for debian/.
  * debian/rules:
    + Stop ignoring test failures on mips64el architecture.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 20 Jan 2025 09:53:12 +0100

=== debian/control ===
Source: morph-browser
Section: x11
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders: Mike Gabriel <sunweaver@debian.org>,
           Marius Gripsgard <marius@debian.org>,
Build-Depends: apparmor:native,
               cmake,
#               apparmor-easyprof,
               debhelper-compat (= 13),
#               dh-apparmor,
               libapparmor-dev,
               libqt5sql5-sqlite,
               lsb-release,
               pkg-config,
               python3-all:any,
               python3-flake8 (>= 2.2.2-1ubuntu4) | python3-flake8:native,
               qml-module-qt-labs-folderlistmodel,
               qml-module-qt-labs-settings,
               qml-module-qtquick2 (>= 5.4),
               qml-module-qtquick-controls2,
               qml-module-qtquick-layouts,
               qml-module-qtsysteminfo,
               qml-module-qttest,
               qml-module-qtwebengine,
               qml-module-lomiri-components,
               qml-module-lomiri-test,
               qml-module-lomiri-components-extras,
               qtbase5-dev (>= 5.4),
               qtbase5-dev-tools,
               qtdeclarative5-dev,
               qttools5-dev-tools,
               qtwebengine5-dev,
               xauth,
               xvfb,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/development/core/morph-browser
Vcs-Browser: https://salsa.debian.org/ubports-team/morph-browser
Vcs-Git: https://salsa.debian.org/ubports-team/morph-browser.git

Package: morph-browser
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends},
         fonts-liberation,
         libqt5sql5-sqlite,
         libqt5webengine5,
         qml-module-qt-labs-folderlistmodel,
         qml-module-qt-labs-settings,
         qml-module-qtquick2 (>= 5.5),
         qml-module-qtquick-controls2,
         qml-module-qtquick-layouts,
         qml-module-qtquick-window2 (>= 5.3),
         qml-module-qtsysteminfo,
         qml-module-morph-web (= ${binary:Version}),
         qml-module-lomiri-content,
         qml-module-lomiri-components-extras,
         qml-module-lomiri-components,
         qml-module-lomiri-action,
Provides: www-browser
Description: Web Browser for Lomiri
 Lightweight web browser tailored for Lomiri, based on the Qt WebEngine
 and using the Lomiri UI components.

Package: morph-webapp-container
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends},
         fonts-liberation,
         libqt5sql5-sqlite,
         libqt5webengine5,
         qml-module-qtquick2 (>= 5.5),
         qml-module-qtquick-window2 (>= 5.3),
         qml-module-sso-onlineaccounts,
         qml-module-morph-web (= ${binary:Version}),
         qml-module-lomiri-content,
         qml-module-lomiri-components,
         qml-module-lomiri-action,
         qml-module-lomiri-onlineaccounts-client,
         morph-browser (= ${binary:Version}),
Description: Morph web applications container
 Lightweight webapp container tailored for Lomiri, based on the
 Qt WebEngine and using the Lomiri UI components.

Package: qml-module-morph-web
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends},
         qml-module-qtwebengine,
         qml-module-qtquick2 (>= 5.4),
         qml-module-qtquick-window2 (>= 5.3),
         qml-module-lomiri-components,
Description: Morph web QML module
 Standalone QML module that contains the WebView component,
 in the Morph.Web namespace.

Package: qml-module-morph-web-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Morph web QML module (HTML documentation)
 A standalone QML module that contains the WebView component,
 in the Morph.Web namespace. This package contains the public
 HTML documentation.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DPKG_GENSYMBOLS_CHECK_LEVEL=4

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# Skip tests on mips64el. The QmlTests crash with segmentation fault at various
# places which makes one guess that there is something odd going on with the
# QmlTest test suite... No deeper motivation to hunt this down on an architecture
# where Lomiri et al. will probably never used on.
testskip_architectures :=

BUILDHOME=/tmp/home

%:
	dh $@

apparmor:
	aa-easyprof -m ./debian/morph-browser-apparmor.manifest --no-verify | \
	egrep -v '(# Click packages|CLICK_DIR)' | \
	sed 's/@{APP_PKGNAME}_@{APP_APPNAME}_@{APP_VERSION}/@{APP_PKGNAME}/g' | \
	sed 's#/run/shm/\.org\.chromium\.Chromium\.\*#/{dev,run}/shm/.org.chromium.Chromium.*#g' | \
	egrep -v 'deny /run/udev/data/\*\* r,' | \
	sed 's#^}$$#\n  /sys/class/ r,\n  /sys/class/input/ r,\n  /run/udev/data/** r,\n}#g' | \
	egrep -v '^\s*deny /dev/ r,\s*$$' | \
	sed 's#^\(\s*\)deny\(\s\+/{run,dev}/shm/pulse-shm\*\s\+w,\).*$$#\1owner\2#g' | \
	sed 's#^}$$#\n  /dev/dri/ r,\n  /sys/devices/pci[0-9]*/**/config r,\n}#g' | \
	sed 's#^}$$#\n  @{HOME}/@{XDG_DOWNLOAD_DIR}/** rwk,\n}#g' \
	> ./debian/usr.bin.morph-browser
ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	apparmor_parser -QTK ./debian/usr.bin.morph-browser
endif

override_dh_install: # apparmor
	mv debian/tmp/usr/share/doc/morph-web debian/tmp/usr/share/doc/qml-module-morph-web
	rmdir debian/tmp/usr/share/doc/qml-module-morph-web/html/images

	dh_install

override_dh_missing:
	dh_missing --fail-missing

override_dh_installdeb:
#	dh_apparmor --profile-name=usr.bin.morph-browser -pmorph-browser
	dh_installdeb

override_dh_clean:
	dh_clean
	rm -rf $(BUILDHOME)

override_dh_auto_test:
	mkdir -p $(BUILDHOME)
ifneq (,$(filter $(DEB_HOST_ARCH),$(testskip_architectures)))
	HOME=$(BUILDHOME) dh_auto_test --no-parallel -- ARGS+=-VV
else
	# FIXME: Temporarily ignore unit test failures on testskip_architectures
	-HOME=$(BUILDHOME) dh_auto_test --no-parallel -- ARGS+=-VV
endif

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

## morph-browser 1.2.0~git20250813.1ca2aa7+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,6 +6,27 @@
 find_package(Gettext REQUIRED)
 
 option(CLICK_MODE "Build as a click package" off)
+option(WERROR "Enable -Werror" off)
+option(ENABLE_QT6 "Enable building with Qt6" OFF)
+
+if (ENABLE_QT6)
+    set(QT_VERSION_MAJOR 6)
+else()
+    set(QT_VERSION_MAJOR 5)
+endif()
+
+find_package(QT NAMES Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)
+find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Gui Qml Quick Svg Test Widgets Sql Network Concurrent DBus WebEngineCore)
+
+# if qt6
+if(${QT_VERSION_MAJOR} GREATER_EQUAL 6)
+    find_package(Qt${QT_VERSION_MAJOR} COMPONENTS REQUIRED WebEngineCore WebEngineQuick WebEngineWidgets WebEngineQuickDelegatesQml Core5Compat)
+else()
+    find_package(Qt${QT_VERSION_MAJOR} COMPONENTS REQUIRED WebEngineCore WebEngine)
+endif()
+
+include(FindPkgConfig)
+pkg_check_modules(LIBAPPARMOR libapparmor REQUIRED)
 
 # Standard install paths
 include(GNUInstallDirs)
@@ -37,14 +58,16 @@
     ENABLE_COVERAGE_REPORT(EXCLUDES tests/*|.*moc_.*.cpp FILTER tests/* moc_*.cpp)
 endif()
 
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17")
+
+if(WERROR)
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
+endif()
 
 # enable QML debugging
 if(CMAKE_BUILD_TYPE MATCHES DEBUG OR CMAKE_BUILD_TYPE MATCHES "Debug")
     add_definitions(-DQT_QML_DEBUG)
 endif()
-
-include(qt5)
 
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 set(CMAKE_AUTOMOC ON)
@@ -62,7 +85,7 @@
 add_subdirectory(src)
 
 enable_testing()
-add_subdirectory(tests)
+#add_subdirectory(tests)
 
 # make non compiled files (QML, JS, images, etc.) visible in QtCreator
 file(GLOB NON_COMPILED_ROOT *.png .gitignore COPYING README snapcraft.yaml)

=== click-hooks/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 project(webapp-container-hook)
 
-find_package(Qt5Core REQUIRED)
+find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)
 
 include_directories(
     ${CMAKE_BINARY_DIR}
@@ -22,7 +22,7 @@
 
 add_executable(${WEBAPP_CONTAINER_HOOK} ${WEBAPP_CONTAINER_HOOK_SRC})
 target_link_libraries(${WEBAPP_CONTAINER_HOOK}
-    Qt5::Core
+    Qt::Core
 )
 
 install(TARGETS ${WEBAPP_CONTAINER_HOOK}

=== doc/CMakeLists.txt ===
project(morph-web-doc)

if(${QT_VERSION_MAJOR} GREATER_EQUAL 6)
    find_package(Qt${QT_VERSION_MAJOR}Tools CONFIG REQUIRED)
    find_package(Qt${QT_VERSION_MAJOR} COMPONENTS ToolsTools CONFIG REQUIRED)
    get_target_property(QDOC_BIN Qt${QT_VERSION_MAJOR}::qdoc LOCATION)
    if (NOT QDOC_BIN)
        message(WARNING "qdoc not found, documentation cannot be built")
    else()
        add_custom_target(doc ALL
                          COMMAND ${QDOC_BIN}
                          -outputdir ${CMAKE_CURRENT_BINARY_DIR}/html
                        ${CMAKE_CURRENT_SOURCE_DIR}/morph-web.qdocconf)
        install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
        DESTINATION ${CMAKE_INSTALL_DATADIR}/doc/morph-web)
    endif()
else()
    find_program(QDOC_BIN qdoc)
    if(QDOC_BIN STREQUAL "QDOC_BIN-NOTFOUND")
        message(WARNING "qdoc not found, documentation cannot be built")
    else()
        add_custom_target(doc ALL
                          COMMAND ${QDOC_BIN} -qt5
                          -outputdir ${CMAKE_CURRENT_BINARY_DIR}/html
                        ${CMAKE_CURRENT_SOURCE_DIR}/morph-web.qdocconf)
        install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
        DESTINATION ${CMAKE_INSTALL_DATADIR}/doc/morph-web)
    endif()
endif()

=== po/CMakeLists.txt ===
find_program(GETTEXT_XGETTEXT_EXECUTABLE xgettext)

set(DOMAIN ${PROJECT_NAME})
set(POT_FILE ${DOMAIN}.pot)

file(STRINGS ${CMAKE_CURRENT_SOURCE_DIR}/LINGUAS LINGUAS
     REGEX "^[^#].*")
string(REGEX MATCHALL "[^ \t]+" LANGS "${LINGUAS}")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/POTFILES.in
               ${CMAKE_CURRENT_BINARY_DIR}/POTFILES COPYONLY
)

# Creates the .pot file containing the translations template
add_custom_target(${POT_FILE} ALL
                  COMMENT "Generating translation template"
                  # Extract the translatable messages from the desktop file
                  COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE} -o ${POT_FILE}
                          --from-code=UTF-8
                          --language=Desktop
                          --package-name='${GETTEXT_PACKAGE}'
                          --copyright-holder='Canonical Ltd.'
                          -D ${CMAKE_BINARY_DIR}/src/app/webbrowser/
                          ${DESKTOP_FILE}.in
                  COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE} -o ${POT_FILE}
                          --from-code=UTF-8
                          --c++
                          --qt
                          --add-comments=TRANSLATORS
                          --keyword=tr
                          --keyword=tr:1,2
                          --keyword=N_
                          --package-name='${PROJECT_NAME}'
                          --copyright-holder='Canonical Ltd.'
                          -D ${CMAKE_SOURCE_DIR}
                          -D ${CMAKE_CURRENT_SOURCE_DIR}
                          -D ${CMAKE_CURRENT_BINARY_DIR}
                          --join-existing
                          --files-from=${CMAKE_CURRENT_BINARY_DIR}/POTFILES)

foreach(LANG ${LANGS})
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${LANG}.po
                   ${CMAKE_CURRENT_BINARY_DIR}/${LANG}.po
                   COPYONLY)
endforeach(LANG)
gettext_process_pot_file(${POT_FILE} ALL
                         INSTALL_DESTINATION ${CMAKE_INSTALL_LOCALEDIR}
                         LANGUAGES ${LANGS})

=== src/CMakeLists.txt ===
add_subdirectory(app)
add_subdirectory(Morph)

if(${QT_VERSION_MAJOR} EQUAL 5)
    # DEPRECATED
    add_subdirectory(Ubuntu)
endif()

=== src/Morph/CMakeLists.txt ===
set(QT_INSTALL_QML "/usr/lib/${CMAKE_LIBRARY_ARCHITECTURE}/qt${QT_VERSION_MAJOR}/qml")

execute_process(COMMAND lsb_release --short --release
    OUTPUT_VARIABLE UBUNTU_VERSION OUTPUT_STRIP_TRAILING_WHITESPACE)
add_definitions(-DUBUNTU_VERSION="${UBUNTU_VERSION}")

add_subdirectory(Web)

=== src/app/CMakeLists.txt ===
project(webbrowser-common)

configure_file(
    config.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/config.h
    @ONLY)

set(COMMONLIB webbrowser-common)

set(COMMONLIB_SRC
    browserapplication.cpp
    browser-utils.cpp
    domain-permissions-model.cpp
    domain-settings-model.cpp
    domain-settings-sorted-model.cpp
    domain-settings-user-agents-model.cpp
    downloads-model.cpp
    favicon-fetcher.cpp
    file-operations.cpp
    input-method-handler.cpp
    meminfo.cpp
    mime-database.cpp
    session-storage.cpp
    single-instance-manager.cpp
    url-utils.cpp
)

add_library(${COMMONLIB} STATIC ${COMMONLIB_SRC})

include_directories(${LIBAPPARMOR_INCLUDE_DIRS})
target_link_libraries(${COMMONLIB}
    Qt::Core
    Qt::CorePrivate
    Qt::Gui
    Qt::Network
    Qt::NetworkPrivate
    Qt::Qml
    Qt::Quick
    Qt::Sql
    Qt::Widgets
    Qt::WebEngineCore
    ${LIBAPPARMOR_LDFLAGS}
)

# if qt6
if(${QT_VERSION_MAJOR} GREATER_EQUAL 6)
    target_link_libraries(${COMMONLIB} Qt::WebEngineCore Qt::WebEngineQuick)
else()
    target_link_libraries(${COMMONLIB} Qt::WebEngine Qt::WebEngineCore)
endif()

install(DIRECTORY qml-qt${QT_VERSION_MAJOR}/ DESTINATION ${CMAKE_INSTALL_DATADIR}/morph-browser)

add_subdirectory(webbrowser)
add_subdirectory(webcontainer)

=== tests/unittests/CMakeLists.txt ===
add_subdirectory(sanity)
add_subdirectory(qml)
add_subdirectory(domain-utils)
add_subdirectory(history-model)
add_subdirectory(history-domain-model)
add_subdirectory(history-domainlist-model)
add_subdirectory(history-lastvisitdatelist-model)
add_subdirectory(session-utils)
add_subdirectory(tabs-model)
add_subdirectory(bookmarks-model)
add_subdirectory(bookmarks-folder-model)
add_subdirectory(bookmarks-folderlist-model)
add_subdirectory(limit-proxy-model)
add_subdirectory(container-url-patterns)
add_subdirectory(cookie-store)
add_subdirectory(oxide-cookie-helper)
add_subdirectory(session-storage)
add_subdirectory(favicon-fetcher)
add_subdirectory(webapp-container-hook)
add_subdirectory(intent-filter)
add_subdirectory(search-engine)
add_subdirectory(text-search-filter-model)
add_subdirectory(downloads-model)
add_subdirectory(single-instance-manager)
add_subdirectory(meminfo)
add_subdirectory(webapp-container-color-helper)
add_subdirectory(url-utils)

=== src/Morph/Web/CMakeLists.txt ===
project(morph-web-plugin)

set(MORPH_WEB_IMPORTS_DIR "${QT_INSTALL_QML}/Morph/Web")

set(PLUGIN morph-web-plugin)

set(PLUGIN_SRC plugin.cpp)

add_library(${PLUGIN} MODULE ${PLUGIN_SRC})
target_link_libraries(${PLUGIN}
    Qt::Core
    Qt::Gui
    Qt::Qml
)

install(TARGETS ${PLUGIN} DESTINATION ${MORPH_WEB_IMPORTS_DIR})
install(DIRECTORY qml-qt${QT_VERSION_MAJOR}/ DESTINATION ${MORPH_WEB_IMPORTS_DIR})

if(NOT ${CMAKE_CURRENT_BINARY_DIR} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR})
  # copy qml files over to build dir to be able to import them uninstalled
  foreach(_file ${PLUGIN_FILES})
    add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${_file}
                       DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${_file}
                       COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_CURRENT_SOURCE_DIR}/${_file} ${CMAKE_CURRENT_BINARY_DIR}/${_file})
  endforeach(_file)
  add_custom_target(copy_files_to_build_dir DEPENDS ${PLUGIN_FILES})
  add_dependencies(${PLUGIN} copy_files_to_build_dir)
endif()

=== src/Ubuntu/Web/CMakeLists.txt ===
project(ubuntu-web-plugin)

set(UBUNTU_WEB_IMPORTS_DIR "${QT_INSTALL_QML}/Ubuntu/Web")

set(PLUGIN ubuntu-web-plugin)

set(PLUGIN_SRC plugin.cpp)

add_library(${PLUGIN} MODULE ${PLUGIN_SRC})
target_link_libraries(${PLUGIN}
    Qt::Core
    Qt::Gui
    Qt::Qml
)

file(GLOB PLUGIN_FILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.qml qmldir *.js *.png)
install(TARGETS ${PLUGIN} DESTINATION ${UBUNTU_WEB_IMPORTS_DIR})
install(FILES ${PLUGIN_FILES} DESTINATION ${UBUNTU_WEB_IMPORTS_DIR})

#if(NOT ${CMAKE_CURRENT_BINARY_DIR} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR})
#  # copy qml files over to build dir to be able to import them uninstalled
#  foreach(_file ${PLUGIN_FILES})
#    add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${_file}
#                       DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${_file}
#                       COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_CURRENT_SOURCE_DIR}/${_file} ${CMAKE_CURRENT_BINARY_DIR}/${_file})
#  endforeach(_file)
#  add_custom_target(copy_files_to_build_dir DEPENDS ${PLUGIN_FILES})
#  add_dependencies(${PLUGIN} copy_files_to_build_dir)
#endif()

=== src/app/webbrowser/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,4 @@
 project(webbrowser-app)
-
-find_package(Qt5Concurrent REQUIRED)
-find_package(Qt5Sql REQUIRED)
 
 include_directories(
     ${CMAKE_BINARY_DIR}
@@ -26,9 +23,10 @@
 
 add_library(${WEBBROWSER_APP_MODELS} STATIC ${WEBBROWSER_APP_MODELS_SRC})
 target_link_libraries(${WEBBROWSER_APP_MODELS}
-    Qt5::Core
-    Qt5::Sql
-#    Qt5::WebEngine
+    Qt::Core
+    Qt::Sql
+    Qt::CorePrivate
+    Qt::NetworkPrivate
 )
 
 set(WEBBROWSER_APP_SRC
@@ -41,10 +39,10 @@
 
 add_executable(${WEBBROWSER_APP} ${WEBBROWSER_APP_SRC})
 target_link_libraries(${WEBBROWSER_APP}
-    Qt5::Concurrent
-    Qt5::Core
-    Qt5::Qml
-    Qt5::Quick
+    Qt::Concurrent
+    Qt::Core
+    Qt::Qml
+    Qt::Quick
     ${COMMONLIB}
     ${WEBBROWSER_APP_MODELS}
 )
@@ -52,8 +50,7 @@
 install(TARGETS ${WEBBROWSER_APP}
         RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
 
-file(GLOB QML_FILES *.qml qmldir *.js)
-install(FILES ${QML_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/morph-browser/webbrowser)
+install(DIRECTORY qml-qt${QT_VERSION_MAJOR}/ DESTINATION ${CMAKE_INSTALL_DATADIR}/morph-browser/webbrowser)
 
 install(DIRECTORY assets
         DESTINATION ${CMAKE_INSTALL_DATADIR}/morph-browser/webbrowser

=== src/app/webcontainer/CMakeLists.txt ===
project(webapp-container)

include_directories(
    ${CMAKE_BINARY_DIR}
    ${webbrowser-common_SOURCE_DIR}
    ${webbrowser-common_BINARY_DIR}
)

set(WEBAPP_CONTAINER webapp-container)

set(WEBAPP_CONTAINER_SRC
    chrome-cookie-store.cpp
    cookie-store.cpp
    online-accounts-cookie-store.cpp
    oxide-cookie-helper.cpp
    local-cookie-store.cpp
    webapp-container.cpp
    webapp-container-helper.cpp
    session-utils.cpp
    url-pattern-utils.cpp
    scheme-filter.cpp
    intent-parser.cpp
)

add_executable(${WEBAPP_CONTAINER} ${WEBAPP_CONTAINER_SRC})

target_link_libraries(${WEBAPP_CONTAINER}
    Qt::Core
    Qt::DBus
    Qt::Gui
    Qt::Qml
    Qt::Quick
    Qt::Sql
    ${COMMONLIB}
)

install(TARGETS ${WEBAPP_CONTAINER}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

install(DIRECTORY qml-qt${QT_VERSION_MAJOR}/ DESTINATION ${CMAKE_INSTALL_DATADIR}/morph-browser/webcontainer)
install(DIRECTORY assets
        DESTINATION ${CMAKE_INSTALL_DATADIR}/morph-browser/webcontainer
        FILES_MATCHING PATTERN *.png)

=== debian/changelog ===
morph-browser (1.2.0~git20250813.1ca2aa7+dfsg-1~exp1) experimental; urgency=medium

  * Upload to experimental.

  * New upstream release preview / Git snapshot.
  * debian/:
    + Build Morph Browser against Qt5 and Qt6 and provide two builds.
  * debian/patches:
    + Drop /0001_fix-is-not-supported-css-selector.patch. Not accepted upstream,
      problem solved on the GitLab side.
    + Rebase 2001_skip-Ubuntu-compat-QML.patch.
  * debian/{rules,watch}:
    + Adjust to building an upstream Git snapshot.
  * debian/copyright:
    + Update Files-Excluded:. Don't include UBports' debian/ folder.
    + Update auto-generated copyright.in file.
    + Update copyright attributions.
    + Update FSF mailing address.
  * debian/:
    + Ship apparmor configuration.
  * debian/control:
    + Bump Standards-Version: to 4.7.2. No changes needed.
    + In B-D, switch from pkg-config to pkgconf. Thanks, lintian.
    + Assure that morph-browser-qt6 has qml6-module-lomiri-content (>= 2.2.0~).
  * lintian: Adjust no-manual-page overrides.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 21 Sep 2025 13:50:50 +0200

=== debian/control ===
--- 
+++ 
@@ -8,11 +8,12 @@
                cmake,
 #               apparmor-easyprof,
                debhelper-compat (= 13),
-#               dh-apparmor,
+               dh-apparmor,
                libapparmor-dev,
                libqt5sql5-sqlite,
+               libqt5svg5-dev,
                lsb-release,
-               pkg-config,
+               pkgconf,
                python3-all:any,
                python3-flake8 (>= 2.2.2-1ubuntu4) | python3-flake8:native,
                qml-module-qt-labs-folderlistmodel,
@@ -28,12 +29,32 @@
                qml-module-lomiri-components-extras,
                qtbase5-dev (>= 5.4),
                qtbase5-dev-tools,
+               qtbase5-private-dev,
                qtdeclarative5-dev,
                qttools5-dev-tools,
                qtwebengine5-dev,
+               qml6-module-qt-labs-folderlistmodel,
+               qml6-module-qt-labs-settings,
+               qml6-module-qtquick,
+               qml6-module-qtquick-controls,
+               qml6-module-qtquick-layouts,
+               qml6-module-lomiri-systeminfo,
+               qml6-module-qttest,
+               qml6-module-qtwebengine,
+               qml6-module-lomiri-components,
+               qml6-module-lomiri-components-extras,
+               qml6-module-lomiri-test,
+               qt6-base-dev,
+               qt6-base-private-dev,
+               qt6-svg-dev,
+               qt6-5compat-dev,
+               qt6-declarative-dev,
+               qt6-tools-dev,
+               qt6-webengine-dev,
+               qt6-documentation-tools | qdoc-qt6,
                xauth,
                xvfb,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://gitlab.com/ubports/development/core/morph-browser
 Vcs-Browser: https://salsa.debian.org/ubports-team/morph-browser
@@ -61,7 +82,7 @@
          qml-module-lomiri-action,
 Provides: www-browser
 Description: Web Browser for Lomiri
- Lightweight web browser tailored for Lomiri, based on the Qt WebEngine
+ Lightweight web browser tailored for Lomiri, based on the Qt 6 WebEngine
  and using the Lomiri UI components.
 
 Package: morph-webapp-container
@@ -81,9 +102,9 @@
          qml-module-lomiri-action,
          qml-module-lomiri-onlineaccounts-client,
          morph-browser (= ${binary:Version}),
-Description: Morph web applications container
+Description: Morph web applications container (Qt 5 variant)
  Lightweight webapp container tailored for Lomiri, based on the
- Qt WebEngine and using the Lomiri UI components.
+ Qt 5 WebEngine and using the Lomiri UI components.
 
 Package: qml-module-morph-web
 Architecture: any
@@ -95,9 +116,11 @@
          qml-module-qtquick2 (>= 5.4),
          qml-module-qtquick-window2 (>= 5.3),
          qml-module-lomiri-components,
-Description: Morph web QML module
+Description: Qt 5 variant Morph web QML module
  Standalone QML module that contains the WebView component,
  in the Morph.Web namespace.
+ .
+ This is the Qt 5 variant of the QML module.
 
 Package: qml-module-morph-web-doc
 Section: doc
@@ -108,3 +131,69 @@
  A standalone QML module that contains the WebView component,
  in the Morph.Web namespace. This package contains the public
  HTML documentation.
+
+Package: morph-browser-qt6
+Architecture: any
+Multi-Arch: foreign
+Depends: ${misc:Depends},
+         ${shlibs:Depends},
+         fonts-liberation,
+         libqt6sql6-sqlite,
+         libqt6webenginecore6,
+         libqt6webengine6-data,
+         qml6-module-qt-labs-folderlistmodel,
+         qml6-module-qt-labs-settings,
+         qml6-module-qtqml-workerscript,
+         qml6-module-qtquick,
+         qml6-module-qtquick-controls,
+         qml6-module-qtquick-layouts,
+         qml6-module-lomiri-systeminfo,
+         qml6-module-morph-web (= ${binary:Version}),
+         qml6-module-lomiri-content (>= 2.2.0~),
+         qml6-module-lomiri-components,
+         qml6-module-lomiri-components-extras,
+         qml6-module-lomiri-action,
+         qml6-module-qtquick-templates,
+Conflicts: webbrowser-app, morph-browser
+Provides: webbrowser-app
+Description: Web Browser for Ubuntu Touch (Qt 6 variant)
+ Lightweight web browser tailored for Ubuntu Touch, based on the Qt 6 WebEngine
+ and using the Lomiri UI components.
+
+#Package: morph-webapp-container-qt6
+#Architecture: any
+#Multi-Arch: foreign
+#Depends: ${misc:Depends},
+#         ${shlibs:Depends},
+#         fonts-liberation,
+#         libqt6sql6-sqlite
+#         libqt6webenginecore6,
+#         libqt6webengine6-data,
+#         qml6-module-qtquick,
+#         qml6-module-qtquick-controls,
+#         qml6-module-sso-onlineaccounts,
+#         qml6-module-morph-web (= ${binary:Version}),
+#         qml6-module-lomiri-content,
+#         qml6-module-lomiri-components,
+#         qml6-module-lomiri-action,
+#         qml-module-lomiri-onlineaccounts-client,
+#         morph-browser-qt6 (= ${binary:Version}),
+#Description: Morph web applications container (Qt 6 variant)
+# A lightweight webapp container tailored for Ubuntu Touch, based on the
+# Qt 6 WebEngine and using the Lomiri UI components.
+
+Package: qml6-module-morph-web
+Architecture: any
+Multi-Arch: same
+Pre-Depends: ${misc:Pre-Depends}
+Depends: ${misc:Depends},
+         ${shlibs:Depends},
+         qml6-module-qtwebengine,
+         qml6-module-qtquick,
+         qml6-module-qtquick-controls,
+         qml6-module-lomiri-components,
+Description: Qt 6 variant of the Morph web QML module
+ A standalone QML module that contains the WebView component,
+ in the Morph.Web namespace.
+ .
+ This is the Qt 6 variant of the QML module.

=== debian/rules ===
--- 
+++ 
@@ -37,18 +37,36 @@
 	apparmor_parser -QTK ./debian/usr.bin.morph-browser
 endif
 
-override_dh_install: # apparmor
-	mv debian/tmp/usr/share/doc/morph-web debian/tmp/usr/share/doc/qml-module-morph-web
-	rmdir debian/tmp/usr/share/doc/qml-module-morph-web/html/images
+override_dh_auto_configure:
+	dh_auto_configure --builddirectory=build-qt6 -- -DENABLE_QT6=ON -DENABLE_WERROR=OFF
+	dh_auto_configure --builddirectory=build-qt5 -- -DENABLE_WERROR=OFF
 
-	dh_install
+override_dh_auto_build:
+	dh_auto_build --builddirectory=build-qt6 ..
+	dh_auto_build --builddirectory=build-qt5 ..
+
+override_dh_auto_install:
+	dh_auto_install --builddirectory=build-qt6 --destdir=debian/tmp-qt6 ..
+	dh_auto_install --builddirectory=build-qt5 --destdir=debian/tmp-qt5 ..
+
+override_dh_install: apparmor
+	mv debian/tmp-qt5/usr/share/doc/morph-web debian/tmp-qt5/usr/share/doc/qml-module-morph-web
+	rmdir debian/tmp-qt5/usr/share/doc/qml-module-morph-web/html/images
+	install -D -m644 ./debian/usr.bin.morph-browser ./debian/tmp-qt5/etc/apparmor.d/usr.bin.morph-browser
+	#install -D -m644 ./debian/usr.bin.morph-browser ./debian/tmp-qt6/etc/apparmor.d/usr.bin.morph-browser
+	dh_install -Nmorph-browser-qt6 -Nqml6-module-morph-web --sourcedir=debian/tmp-qt5
+	dh_install -pmorph-browser-qt6 -pqml6-module-morph-web --sourcedir=debian/tmp-qt6
 
 override_dh_missing:
 	dh_missing --fail-missing
 
 override_dh_installdeb:
-#	dh_apparmor --profile-name=usr.bin.morph-browser -pmorph-browser
+	dh_apparmor --profile-name=usr.bin.morph-browser -pmorph-browser
 	dh_installdeb
+
+override_dh_auto_clean:
+	dh_auto_clean --builddirectory=build-qt6
+	dh_auto_clean --builddirectory=build-qt5
 
 override_dh_clean:
 	dh_clean
@@ -63,5 +81,40 @@
 	-HOME=$(BUILDHOME) dh_auto_test --no-parallel -- ARGS+=-VV
 endif
 
-get-orig-source:
-	uscan --noconf --force-download --rename --download-current-version --destdir=..
+include /usr/share/dpkg/pkg-info.mk
+
+PKD   = $(word 1,$(abspath $(dir $(MAKEFILE_LIST))))
+PKG   = $(DEB_SOURCE)
+UVER  = $(shell echo $(DEB_VERSION) | cut -d "-" -f1)
+DTYPE = +dfsg
+VER  ?= $(subst $(DTYPE),,$(UVER))
+
+UURL = https://gitlab.com/ubports/development/core/morph-browser.git
+UREV = $(shell echo $(VER) | cut -d"." -f4)
+
+## http://wiki.debian.org/onlyjob/get-orig-source
+.PHONY: get-orig-source
+get-orig-source: $(PKG)_$(VER)$(DTYPE).orig.tar.xz $(info I: $(PKG)_$(VER)$(DTYPE))
+	@
+
+$(PKG)_$(VER)$(DTYPE).orig.tar.xz: $(info I: GIT Revision=$(UREV))
+	$(if $(wildcard $(PKG)-$(VER)),$(error $(PKG)-$(VER) exist, aborting..))
+	@echo "# Downloading..."
+	git clone $(UURL) $(PKG)-$(VER) \
+	   || $(RM) -r $(PKG)-$(VER)
+	cd $(PKG)-$(VER) \
+	   && git checkout "$(UREV)" \
+	   && ( echo "# Generating ChangeLog..." \
+	      ; git --no-pager log --format="%ai %aN (%h) %n%n%x09*%w(68,0,10) %s%n" > ChangeLog \
+	      ; touch -d "$$(git log -1 --format='%ci')" ChangeLog) \
+	   && echo "# Setting times..." \
+	   && for F in $$(git ls-tree -r --name-only HEAD); do touch --no-dereference -d "$$(git log -1 --format="%ai" -- $$F)" "$$F"; done \
+	   && echo "# Cleaning-up..." \
+	   && rm -rf debian \
+	   && rm -rf src/Ubuntu \
+	   && rm -rf tests/autopilot \
+	   && rm -rf .git .git*
+	@echo "# Packing..."
+	find -L "$(PKG)-$(VER)" -xdev -type f -print | sort \
+	   | XZ_OPT="-6v" tar -caf "../$(PKG)_$(VER)$(DTYPE).orig.tar.xz" -T- --owner=root --group=root --mode=a+rX \
+	   && $(RM) -r "$(PKG)-$(VER)"

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none,  pretty=1.2.0~git%cd.%h, repacksuffix=+dfsg, dversionmangle=s/\+dfsg//" \
https://gitlab.com/ubports/development/core/morph-browser.git heads/personal/gberh/qt6 debian uupdate
